Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 1795053 (wfuzz) - Review Request: wfuzz - Web fuzzer
Summary: Review Request: wfuzz - Web fuzzer
Keywords:
Status: CLOSED ERRATA
Alias: wfuzz
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Dan Čermák
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: FE-SECLAB
TreeView+ depends on / blocked
 
Reported: 2020-01-26 18:05 UTC by Fabian Affolter
Modified: 2020-04-01 16:32 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-04-01 00:17:07 UTC
Type: ---
Embargoed:
dan.cermak: fedora-review+


Attachments (Terms of Use)

Description Fabian Affolter 2020-01-26 18:05:00 UTC
Spec URL: https://fab.fedorapeople.org/packages/SRPMS/wfuzz.spec
SRPM URL: https://fab.fedorapeople.org/packages/SRPMS/wfuzz-2.4.5-1.fc31.src.rpm

Project URL: http://wfuzz.io

Description:
Wfuzz has been created to facilitate the task in web applications assessments
and it is based on a simple concept: it replaces any reference to the FUZZ
keyword by the value of a given payload.

Koji scratch build:
https://koji.fedoraproject.org/koji/taskinfo?taskID=41046574

rpmlint output:
$ rpmlint wfuzz-2.4.5-1.fc31.src.rpm
wfuzz.src: W: spelling-error Summary(en_US) fuzzer -> fuzzier, fuzzes, fuzzed
wfuzz.src:22: W: macro-in-comment %package
wfuzz.src:22: W: macro-in-comment %{name}
wfuzz.src:23: W: macro-in-comment %{name}
wfuzz.src:28: W: macro-in-comment %description
wfuzz.src:28: W: macro-in-comment %{name}
wfuzz.src:29: W: macro-in-comment %{name}
wfuzz.src:56: W: macro-in-comment %files
wfuzz.src:56: W: macro-in-comment %{name}
wfuzz.src:57: W: macro-in-comment %doc
wfuzz.src:58: W: macro-in-comment %license
wfuzz.src: E: specfile-error warning: Macro expanded in comment on line 22: %{name}-doc
wfuzz.src: E: specfile-error 
wfuzz.src: E: specfile-error warning: Macro expanded in comment on line 23: %{name} documentation
wfuzz.src: E: specfile-error 
wfuzz.src: E: specfile-error warning: Macro expanded in comment on line 28: %{name}-doc
wfuzz.src: E: specfile-error 
wfuzz.src: E: specfile-error warning: Macro expanded in comment on line 29: %{name}.
wfuzz.src: E: specfile-error 
wfuzz.src: E: specfile-error warning: Macro expanded in comment on line 56: %{name}-doc
1 packages and 0 specfiles checked; 9 errors, 11 warnings.

$ rpmlint wfuzz-2.4.5-1.fc31.noarch.rpm 
wfuzz.noarch: W: spelling-error Summary(en_US) fuzzer -> fuzzier, fuzzes, fuzzed
wfuzz.noarch: E: non-executable-script /usr/lib/python3.7/site-packages/wfuzz/wfuzz.py 644 /usr/bin/env python
wfuzz.noarch: W: no-manual-page-for-binary wfencode
wfuzz.noarch: W: no-manual-page-for-binary wfpayload
wfuzz.noarch: W: no-manual-page-for-binary wfuzz
wfuzz.noarch: W: no-manual-page-for-binary wxfuzz
1 packages and 0 specfiles checked; 1 errors, 5 warnings.

Fedora Account System Username: fab

Comment 1 Dan Čermák 2020-02-06 20:21:41 UTC
Overall this looks good, I have the following questions/comments:

- please don't put plain macros into comments, that's just asking for trouble with m4, prevent their expansion via %% or replace the # with %dnl (will only work in Rawhide & F32 though)
- upstream has a test suite, consider running it in %check?
- you have added 3 sed calls into %prep:
  * please add an explanation why you have added these and what they do
  * You unrestrict the pycurl dependency: given that you don't run any tests, this seems a bit dangerous, especially given this oddly specific version requirement (and that we have a newer version in Rawhide). If you believe that the dependency specification is wrong, then please submit a patch upstream and patch the sources in the spec.
- The documentation is not built, why? If there is an upstream issue, please link to it.

Comment 2 Fabian Affolter 2020-02-28 12:14:33 UTC
(In reply to dan.cermak from comment #1)
> Overall this looks good, I have the following questions/comments:
> 
> - please don't put plain macros into comments, that's just asking for
> trouble with m4, prevent their expansion via %% or replace the # with %dnl
> (will only work in Rawhide & F32 though)

Doc building is no longer excluded.

> - upstream has a test suite, consider running it in %check?

They have but it's required to run a server as the calls are not mocked. I'm not aware that the build system is able to run containers.

> - you have added 3 sed calls into %prep:
>   * please add an explanation why you have added these and what they do
>   * You unrestrict the pycurl dependency: given that you don't run any
> tests, this seems a bit dangerous, especially given this oddly specific
> version requirement (and that we have a newer version in Rawhide). If you
> believe that the dependency specification is wrong, then please submit a
> patch upstream and patch the sources in the spec.

Strict release pinning breaks the installations. There is an issue with 7.43.0.3. Fedora 31 ships 7.43.0.2 and Fedora 32 7.43.0.5. With both versions of pycurl I'm not able to reproduce the reported issues. Thus I removed the pinning. 

> - The documentation is not built, why? If there is an upstream issue, please
> link to it.

This issue seems to be resolved now.

Update files:
Spec URL: https://fab.fedorapeople.org/packages/SRPMS/wfuzz.spec
SRPM URL: https://fab.fedorapeople.org/packages/SRPMS/wfuzz-2.4.5-2.fc31.src.rpm

Comment 3 Dan Čermák 2020-03-20 20:24:26 UTC
(In reply to Fabian Affolter from comment #2)
> > - upstream has a test suite, consider running it in %check?
> 
> They have but it's required to run a server as the calls are not mocked. I'm
> not aware that the build system is able to run containers.

That is indeed not possible as far as I know. You could look into Fedora CI for that: https://docs.fedoraproject.org/en-US/ci/, but that is beyond the scope of this review.

> 
> > - you have added 3 sed calls into %prep:
> >   * please add an explanation why you have added these and what they do
> >   * You unrestrict the pycurl dependency: given that you don't run any
> > tests, this seems a bit dangerous, especially given this oddly specific
> > version requirement (and that we have a newer version in Rawhide). If you
> > believe that the dependency specification is wrong, then please submit a
> > patch upstream and patch the sources in the spec.
> 
> Strict release pinning breaks the installations. There is an issue with
> 7.43.0.3. Fedora 31 ships 7.43.0.2 and Fedora 32 7.43.0.5. With both
> versions of pycurl I'm not able to reproduce the reported issues. Thus I
> removed the pinning. 
> 

I see, let's hope that there won't be an update to a broken pycurl version in Fedora 31 then.


There's one small thing left: the newest changelog entry has an empty line?

Since the major issues got fixed, I'll approve the package. Please fix the changelog though before uploading to dist-git.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 176 files have unknown license.
     Detailed output of licensecheck in /home/dan/fedora-
     scm/1795053-wfuzz/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.

Comment 4 Fabian Affolter 2020-03-23 10:56:38 UTC
Thanks for your time to review this.

Comment 5 Igor Raits 2020-03-23 11:08:40 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/wfuzz

Comment 6 Fedora Update System 2020-03-24 01:52:13 UTC
FEDORA-2020-d505615c49 has been pushed to the Fedora 32 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-d505615c49 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-d505615c49

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 7 Fedora Update System 2020-04-01 00:17:07 UTC
FEDORA-2020-d505615c49 has been pushed to the Fedora 32 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 8 Fedora Update System 2020-04-01 16:32:09 UTC
FEDORA-2020-d505615c49 has been pushed to the Fedora 32 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.